<HTML>
<!--
#TITLE Free Pascal - The mysql unit.
#ENTRY prog
#SUBENTRY packages
#SUBSUBENTRY mysql
#MAINDIR ..
#HEADGIF NotYetHere
#HEADALT The mysql unit.
-->
<H1>Free Pascal interface to MySQL</H1>

<H2>Overview</H2>
You can use Free Pascal to access a MySQL database server from Linux. 
(for more info on MySQL, see their <A HREF="http://www.tcx.se/"> home page</A>.)<P>

Interfacing is very easy, all you need to do is compile some units, and use
these units in your program. You need to specify the place of the MySQL
client Library (<TT>libmysqlclient</TT> when compiling, and that is it.
the provided units take care of the rest.

<H2>Installation</H2>
The mysql interface is distributed with the Free Pascal packages,
and come with the compiler. You can download the units also
<A HREF="ftp://ftp.freepascal.org/pub/fpc/source/packages.zip">here</A>. <P>
This contains a directory mysql with the units, a test program and
a makefile. cd to the directory and edit the <TT>Makefile</TT> to set the
variables for your system. You must provide at least 2 things:
<OL>
<LI> The directory where the <TT>mysqlclient</TT> library resides, usually
<TT>/usr/local/lib/mysql</TT>
<LI> The directory where the <TT>gcc</TT>library resides. This looks
something like <TT>/usr/lib/gcc-lib/i486-linux/2.7.2</TT>. It depends on
what your version of GNU CC is. (normally the makefile detects this by
itself, though).
</OL>
Typing
<PRE>
make
</PRE>
Should compile the units and the program. If compilation was succesfull,
you can install with 
<PRE>
make install
</PRE>
(Remember to set the directory where the units should be installed.)<P>
You can then test the program by running
<PRE>
make test
</PRE>
This will: 
<UL>
<LI> Run a script to create a table in a database, and fill it with some
data. (the <TT>mysql</TT> program should be in
your PATH for this) . By default, the used database is <TT>testdb</TT>.
<LI> Run the testprogram <TT>testdb</TT>
<LI> Run a shell script again to remove the created table.
</UL>
You will see a lot of messages on your screen, giving you feedback and
results. If something went wrong, <TT>make</TT> will inform you of this.
<H2>Future plans</H2>
The interface to mysql is a pure translation of the mysql C header files.
This means that the used functions are rather un-pascalish. It would be
great to have an OOP interface for it, A la Delphi. This interface is being
worked on.<P>
<H2>Finally</H2>
If you have found a bug, or if you have made some functions to interface
these units in a more pascal-like fashion, feel free to contact me at
<A HREF="mailto:michael.vancanneyt@freepascal.org">michael.vancanneyt@freepascal.org</A><P><P><P>

<A HREF="../packages.html">Back to packages page</A>. 

<HR>
</HTML>